#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <stdlib.h>
#include <bautils.h>
#include <eikenv.h>

#if defined (EPOC_AS_APP) && !defined (UIQ3) && !defined (S60V3)
#include "ECompXL.h"
#endif

class CAbuseApp : public CSDLApp {
public:
	CAbuseApp();
	~CAbuseApp();
	/**
	* This has a default empty implementation.
	* Is called just before SDL_Main is called to allow init of system vars
	*/
	void PreInitializeAppL();
#if defined (UIQ3)
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif
	TUid AppDllUid() const;
#if defined (EPOC_AS_APP) && !defined (UIQ3) && !defined (S60V3)
	TECompXL    iECompXL;
#endif
};

#ifdef EPOC_AS_APP

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined (S60V3)
EXPORT_C
#endif
CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new CAbuseApp;
}

#if defined (UIQ3) || defined (S60V3)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (S60V3)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif

CAbuseApp::CAbuseApp() {
}

CAbuseApp::~CAbuseApp() {
}

#if defined (UIQ3)
#include <abuse.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CAbuseApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CAbuseApp::AppDllUid() const {
	return TUid::Uid(0xA00048D3);
}
_LIT(KResourceAppsDataPath, "%c:\\resource\\apps\\abuse\\");
#ifdef UIQ3
_LIT(KResourceSharedDataPath, "%c:\\shared\\abuse\\");
#else
_LIT(KResourceSharedDataPath, "%c:\\data\\abuse\\");
#endif
/**
 * This has a default empty implementation.
 * Is called just before SDL_Main is called to allow init of system vars
 */
void CAbuseApp::PreInitializeAppL()
{
	TBuf8<256> datapath;
	TFileName fileName;
	
	RFs rfs;
	rfs.Connect();
	fileName.Format(KResourceAppsDataPath(), 'E');
	if(!BaflUtils::PathExists(rfs, fileName) )
	{
		fileName.Format(KResourceAppsDataPath, 'D');
		if(!BaflUtils::PathExists(rfs, fileName) )
		{
			fileName.Format(KResourceAppsDataPath, 'C');
			if(!BaflUtils::PathExists(rfs, fileName) )
			{
				fileName.Format(KResourceSharedDataPath, 'E');
				if(!BaflUtils::PathExists(rfs, fileName) )
				{
					fileName.Format(KResourceSharedDataPath, 'D');
					if(!BaflUtils::PathExists(rfs, fileName) )
					{
						fileName.Format(KResourceSharedDataPath, 'C');	
						if(!BaflUtils::PathExists(rfs, fileName) )
						{
							User::Leave(KErrNotFound);
						}
					}
				}
			}
			
		}
	}
	rfs.Close();
	datapath.Copy(fileName);
	setenv("ABUSE_PATH", (const char*) datapath.PtrZ(), 1);
	setenv("HOME", GetExecutablePathCStr(), 1);
	setenv("ABUSE_SAVE_PATH", GetExecutablePathCStr(), 1);
}

/////////////////////////////////////////////////////////////////////////////////////////////////


